/**********************************
 *                                *
 *  ** HAPPy Pascal compiler **   *
 *     P-code \[X          *
 *                                *
 *   Copyright (c) H.Asano 1992   *
 **********************************/

#define  EXTERN  extern
#include <stdio.h>
#include "pascomp.h"
#include "pcpcd.h"

extern char *version   ;                /* HAPPỹo[Wԍ      */
extern FILE *pcdfile   ;                /* PR[ho̓t@C        */


/***** function prototype *****/
extern void pcerr(int,char*)      ;
extern boolean string(stp*)   ;
extern void getbounds(stp*,long*,long*) ;
extern void term(void) ;

/********** P-code j[jbN `\ **********/

static struct {
   char    *mn     ;                   /* P-code mnemonics            */
   short   cdx     ;                   /* stack pointer̓         */
} icd[iZZZ] ;

static struct {
   char    *sna    ;                  /* standard proc&func mnemonics */
   short   pdx     ;                  /* stack pointer̓          */
} pcd[pZZZ] ;

/***************************************/
/* initpcd() : P-code֘A ݒ菈 */
/***************************************/
void initpcd(void)
{
  /**** P-code instruction mnmonics  o^ *****/
     icd[iABI].mn  = "abi" ;  icd[iABI].cdx = 0 ;
     icd[iABR].mn  = "abr" ;  icd[iABR].cdx = 0 ;
     icd[iADI].mn  = "adi" ;  icd[iADI].cdx =-1 ;
     icd[iADR].mn  = "adr" ;  icd[iADR].cdx =-1 ;
     icd[iAND].mn  = "and" ;  icd[iAND].cdx =-1 ;
     icd[iBAS].mn  = "bas" ;  icd[iBAS].cdx =+1 ;
     icd[iCHK].mn  = "chk" ;  icd[iCHK].cdx = 0 ;
     icd[iCHR].mn  = "chr" ;  icd[iCHR].cdx = 0 ;
     icd[iCKA].mn  = "cka" ;  icd[iCKA].cdx = 0 ;
     icd[iCSP].mn  = "csp" ;  icd[iCSP].cdx = 0 ;
     icd[iCUI].mn  = "cui" ;  icd[iCUI].cdx =-1 ;
     icd[iCUP].mn  = "cup" ;  icd[iCUP].cdx = 0 ;
     icd[iDEC].mn  = "dec" ;  icd[iDEC].cdx = 0 ;
     icd[iDIF].mn  = "dif" ;  icd[iDIF].cdx =-1 ;
     icd[iDVI].mn  = "dvi" ;  icd[iDVI].cdx =-1 ;
     icd[iDVR].mn  = "dvr" ;  icd[iDVR].cdx =-1 ;
     icd[iEJP].mn  = "ejp" ;  icd[iEJP].cdx = 0 ;  /* cdxl͖     */
     icd[iENT].mn  = "ent" ;  icd[iENT].cdx = 0 ;
     icd[iEQU].mn  = "equ" ;  icd[iEQU].cdx =-1 ;
     icd[iFJP].mn  = "fjp" ;  icd[iFJP].cdx =-1 ;
     icd[iFLO].mn  = "flo" ;  icd[iFLO].cdx = 0 ;
     icd[iFLT].mn  = "flt" ;  icd[iFLT].cdx = 0 ;
     icd[iGEQ].mn  = "geq" ;  icd[iGEQ].cdx =-1 ;
     icd[iGRT].mn  = "grt" ;  icd[iGRT].cdx =-1 ;
     icd[iINC].mn  = "inc" ;  icd[iINC].cdx = 0 ;
     icd[iIND].mn  = "ind" ;  icd[iIND].cdx = 0 ;
     icd[iINN].mn  = "inn" ;  icd[iINN].cdx =-1 ;
     icd[iINT].mn  = "int" ;  icd[iINT].cdx =-1 ;
     icd[iIOR].mn  = "ior" ;  icd[iIOR].cdx =-1 ;
     icd[iIXA].mn  = "ixa" ;  icd[iIXA].cdx =-1 ;
     icd[iLAO].mn  = "lao" ;  icd[iLAO].cdx =+1 ;
     icd[iLAP].mn  = "lap" ;  icd[iLAP].cdx =+1 ;
     icd[iLCA].mn  = "lca" ;  icd[iLCA].cdx =+1 ;
     icd[iLDA].mn  = "lda" ;  icd[iLDA].cdx =+1 ;
     icd[iLDC].mn  = "ldc" ;  icd[iLDC].cdx =+1 ;
     icd[iLDO].mn  = "ldo" ;  icd[iLDO].cdx =+1 ;
     icd[iLEQ].mn  = "leq" ;  icd[iLEQ].cdx =-1 ;
     icd[iLES].mn  = "les" ;  icd[iLES].cdx =-1 ;
     icd[iLOD].mn  = "lod" ;  icd[iLOD].cdx =+1 ;
     icd[iMMS].mn  = "mms" ;  icd[iMMS].cdx =-1 ;
     icd[iMOD].mn  = "mod" ;  icd[iMOD].cdx =-1 ;
     icd[iMOV].mn  = "mov" ;  icd[iMOV].cdx =-2 ;
     icd[iMPI].mn  = "mpi" ;  icd[iMPI].cdx =-1 ;
     icd[iMPR].mn  = "mpr" ;  icd[iMPR].cdx =-1 ;
     icd[iMSI].mn  = "msi" ;  icd[iMSI].cdx =-1 ;
     icd[iMST].mn  = "mst" ;  icd[iMST].cdx = 0 ;
     icd[iNEQ].mn  = "neq" ;  icd[iNEQ].cdx =-1 ;
     icd[iNGI].mn  = "ngi" ;  icd[iNGI].cdx = 0 ;
     icd[iNGR].mn  = "ngr" ;  icd[iNGR].cdx = 0 ;
     icd[iNOT].mn  = "not" ;  icd[iNOT].cdx = 0 ;
     icd[iODD].mn  = "odd" ;  icd[iODD].cdx = 0 ;
     icd[iORD].mn  = "ord" ;  icd[iORD].cdx = 0 ;
     icd[iRET].mn  = "ret" ;  icd[iRET].cdx = 0 ;
     icd[iROU].mn  = "rou" ;  icd[iROU].cdx = 0 ;
     icd[iSBI].mn  = "sbi" ;  icd[iSBI].cdx =-1 ;
     icd[iSBR].mn  = "sbr" ;  icd[iSBR].cdx =-1 ;
     icd[iSGS].mn  = "sgs" ;  icd[iSGS].cdx = 0 ;
     icd[iSQI].mn  = "sqi" ;  icd[iSQI].cdx = 0 ;
     icd[iSQR].mn  = "sqr" ;  icd[iSQR].cdx = 0 ;
     icd[iSRO].mn  = "sro" ;  icd[iSRO].cdx =-1 ;
     icd[iSTO].mn  = "sto" ;  icd[iSTO].cdx =-2 ;
     icd[iSTP].mn  = "stp" ;  icd[iSTP].cdx = 0 ;
     icd[iSTR].mn  = "str" ;  icd[iSTR].cdx =-1 ;
     icd[iTRA].mn  = "tra" ;  icd[iTRA].cdx = 0 ;
     icd[iTRC].mn  = "trc" ;  icd[iTRC].cdx = 0 ;
     icd[iUJC].mn  = "ujc" ;  icd[iUJC].cdx = 0 ;
     icd[iUJP].mn  = "ujp" ;  icd[iUJP].cdx = 0 ;
     icd[iUNI].mn  = "uni" ;  icd[iUNI].cdx =-1 ;
     icd[iXJP].mn  = "xjp" ;  icd[iXJP].cdx =-1 ;

  /**** P-code standard proc&func mnmonics  o^ ****/
     pcd[pATN].sna = "atn" ;  pcd[pATN].pdx = 0 ;
     pcd[pCOS].sna = "cos" ;  pcd[pCOS].pdx = 0 ;
     pcd[pDIS].sna = "dis" ;  pcd[pDIS].pdx =-2 ;
     pcd[pEOF].sna = "eof" ;  pcd[pEOF].pdx = 0 ;
     pcd[pEOL].sna = "eol" ;  pcd[pEOL].pdx = 0 ;
     pcd[pEXP].sna = "exp" ;  pcd[pEXP].pdx = 0 ;
     pcd[pGET].sna = "get" ;  pcd[pGET].pdx =-1 ;
     pcd[pLOG].sna = "log" ;  pcd[pLOG].pdx = 0 ;
     pcd[pNEW].sna = "new" ;  pcd[pNEW].pdx =-2 ;
     pcd[pPGE].sna = "pge" ;  pcd[pPGE].pdx =-1 ;
     pcd[pPUT].sna = "put" ;  pcd[pPUT].pdx =-1 ;
     pcd[pRDC].sna = "rdc" ;  pcd[pRDC].pdx =-2 ;
     pcd[pRDI].sna = "rdi" ;  pcd[pRDI].pdx =-2 ;
     pcd[pRDR].sna = "rdr" ;  pcd[pRDR].pdx =-2 ;
     pcd[pRLN].sna = "rln" ;  pcd[pRLN].pdx =-1 ;
     pcd[pRST].sna = "rst" ;  pcd[pRST].pdx =-1 ;
     pcd[pRWT].sna = "rwt" ;  pcd[pRWT].pdx =-1 ;
     pcd[pSIN].sna = "sin" ;  pcd[pSIN].pdx = 0 ;
     pcd[pSQT].sna = "sqt" ;  pcd[pSQT].pdx = 0 ;
     pcd[pTGT].sna = "tgt" ;  pcd[pTGT].pdx =-1 ;
     pcd[pTPT].sna = "tpt" ;  pcd[pTPT].pdx =-1 ;
     pcd[pTRS].sna = "trs" ;  pcd[pTRS].pdx =-1 ;
     pcd[pTRW].sna = "trw" ;  pcd[pTRW].pdx =-1 ;
     pcd[pWLN].sna = "wln" ;  pcd[pWLN].pdx =-1 ;
     pcd[pWRB].sna = "wrb" ;  pcd[pWRB].pdx =-3 ;
     pcd[pWRC].sna = "wrc" ;  pcd[pWRC].pdx =-3 ;
     pcd[pWRF].sna = "wrf" ;  pcd[pWRF].pdx =-4 ;
     pcd[pWRI].sna = "wri" ;  pcd[pWRI].pdx =-3 ;
     pcd[pWRR].sna = "wrr" ;  pcd[pWRR].pdx =-3 ;
     pcd[pWRS].sna = "wrs" ;  pcd[pWRS].pdx =-4 ;
}

/****************************************/
/* errchk() : P-code\[Xt@Cւ  */
/*            o͂ŃG[    */
/*            ׂ                    */
/****************************************/
static void errchk(int returnfprintf)
{
     if(returnfprintf == EOF) {
       pcerr(701,"") ;
       term()        ;                  /* I                   */
     }  
}
       
/**********************************/
/* mes(): X^bN̕Kvʂ𒲂ׂ*/
/*          --> topmax            */
/**********************************/
static void mes(int i)
{
     topnew += icd[i].cdx*maxstack ;
     if(topnew > topmax) topmax = topnew ;
}

/***************************************/
/*   putic() : P-CODEto      */
/*    \[X̍sԍo͂         */   
/***************************************/
static void putic(void)
{
  static oldlineno = 0;

     if(! pcdinf) return ;              /* P-code information off ̎*/

     if(oldlineno != lineno) {
      oldlineno = lineno ;
      errchk(fprintf(pcdfile,"; %s(%d)\n",passname,lineno)) ;
                                        /* \[Xt@Csԍo*/
     } 
}

/************************************************/
/*     gentypindicator(): ^̏o            */
/*         i : integer & 񋓌^                 */
/*         b : boolean                          */
/*         c : char       r : real              */
/*         a : pointer    s : set               */
/*         m : records & arrays                 */
/************************************************/
static void gentypindicator(stp *fsp)
{
  char *type ;

     if(!fsp) {                         /* ^Ȃ                 */
      errchk(fprintf(pcdfile," ")) ;    /* 󔒂o͂ďI       */
      return ;
     }

     switch(fsp->form) {
      case scalar :                     /* XJ[^                 */
        if(fsp == intptr)        type = "i" ;
        else if (fsp == boolptr) type = "b" ;
        else if (fsp == charptr) type = "c" ;
        else if (fsp->sf.sc.scalkind == declared) type = "i" ;
        else                     type = "r" ;
        errchk(fprintf(pcdfile,type)) ;
        break ;
        
      case subrange :                   /* ͈͌^                     */
        gentypindicator(fsp->sf.su.rangetype) ;
        break ;                         /* ̌^ɂĒׂ       */

      case pointer :                    /* |C^^                 */
        errchk(fprintf(pcdfile,"a")) ;
        break       ;

      case power   :                    /* W^                     */
        errchk(fprintf(pcdfile,"s")) ;
        break ;

      case records :                    /* R[h                   */
      case arrays  :                    /* z                       */
        errchk(fprintf(pcdfile,"m")) ;
        break ;

   /* case files   : */
   /* case tagfld  : */
   /* case variant : */
                                        /* ̃[g֗Ă͂Ȃ */
     }
}

/************************************************/
/*    putconstant(): 萔̏o                 */
/*                      / W /      */
/************************************************/
static void putconst(void)
{
  int i ;

     switch(gattr.cval.valp->cclass) {  /* 萔̎ނɂU蕪 */
      case real :                       /*                        */
        errchk(fprintf(pcdfile,"%s\n",gattr.cval.valp->c.rval)) ;
        break ;

      case pset :                       /* W                       */
        errchk(fprintf(pcdfile,"(")) ;
        for(i=0; i<=sethigh; i++)
         if(inset(gattr.cval.valp->c.pval,i))  /*  vf鎞       */
          errchk(fprintf(pcdfile,"%3d",i)) ;
        errchk(fprintf(pcdfile,")\n")) ;
        break ;

      case strg :                       /*                      */
        errchk(fprintf(pcdfile,"\"%s\"\n",gattr.cval.valp->c.sval)) ;
     }
}

/***************************************/
/*  crelabel() :xl̐         */
/***************************************/
int crelabel(void)
{
  static int labelvalue = 0 ;
  
     return(++labelvalue) ;
}

/**************************************/
/* putlabel(): x̏o           */
/**************************************/
void putlabel(int labname)
{
     if(!pcode) return ;                /* o͕svȂ烊^[ */
     errchk(fprintf(pcdfile,"L%d\n",labname)) ;
}

/**************************************/
/* putlblv(): xl̏o          */
/**************************************/
void putlblv(int labname, int labvalue)
{
     if(!pcode) return ;                /* o͕svȂ烊^[ */
     errchk(fprintf(pcdfile,"L%d=%4d\n", labname, labvalue)) ;
}

/**************************************/
/* putprogname(): vȌo  */
/**************************************/
void putprogname(char *progname)
{
     if(!pcode) return ;                /* o͕svȂ烊^[ */
     errchk(
   fprintf(pcdfile,"; Writen by HAPPy Pascal Compiler Version %s\n",version));
     errchk(fprintf(pcdfile,"; Pascal source file name=%s\n",passname));
     errchk(fprintf(pcdfile,"N %s\n", progname));
}

/**************************************/
/* putfilename(): t@C̏o    */
/*         F ̧ٖ ڽ         */
/**************************************/
void putfilename(char *name, int adr,int size)
{
     if(!pcode) return ;                /* o͕svȂ烊^[ */
     putic()           ;
     errchk(fprintf(pcdfile,"F %s %5d %5d\n", name,adr,size));
}

/**************************************/
/* putq(): quitw̏o             */
/**************************************/
void putq(void)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     errchk(fprintf(pcdfile,"Q\n"));
}

/**************************************/
/* gen0(): IyĥȂP-codeo */
/**************************************/
void gen0(enum pcdmnc fop)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile," %s\n",icd[fop].mn)) ;
     mes(fop) ;
     ic++ ;
}

/************************************************/
/* gen1(): p[^1Ť ^̂ȂP-codeo  */
/*               lao mst mov                    */
/************************************************/
void gen1(enum pcdmnc fop, int fq)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic()  ;
     errchk(fprintf(pcdfile," %s%12d\n",icd[fop].mn,fq)) ;
     mes(fop) ;
     ic++     ;
}

/*************************************************/
/*    gen0t() : p[^ȂČ^̂閽 */
/*                 ̏o                        */
/*************************************************/
void gen0t(enum pcdmnc fop,stp *fsp)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile," %s",icd[fop].mn));/* j[jbNo   */
     gentypindicator(fsp)  ;            /* ^̏o                   */
     errchk(fprintf(pcdfile,"\n")) ;

     mes(fop) ;
     ic++  ;
}

/************************************************/
/*    gen1t() : p[^1Ō^̂閽   */
/*                 ̏o                       */
/************************************************/
void gen1t(enum pcdmnc fop,stp *fsp, int fq)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile," %s",icd[fop].mn));/* j[jbNo   */
     gentypindicator(fsp) ;             /* ^̏o                   */
     errchk(fprintf(pcdfile,"%11d\n",fq)) ;

     mes(fop) ;
     ic++  ;
}

/************************************************/
/*    gen2t() : p[^2Ō^̂閽 */
/*                 ̏o                       */
/************************************************/
void gen2t(enum pcdmnc fop, stp *fsp, int fp,int fq)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile," %s",icd[fop].mn));/* j[jbNo   */
     gentypindicator(fsp) ;             /* ^̏o                   */
     errchk(fprintf(pcdfile," %2d %7d\n",fp,fq)); /* p  q ̏o    */
                          
     mes(fop) ;
     ic++  ;
}

/************************************************/
/*    gencsp(): csp߂̏o                   */
/************************************************/
void gencsp(enum pcdprmnc pc)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile," %s%12s\n", icd[iCSP].mn, pcd[pc].sna)) ;
     topnew = topnew + pcd[pc].pdx * maxstack ;
     if(topnew > topmax) topmax = topnew ;
     ic++ ;
}

/************************************************/
/*    genret(): ret߂̏o                   */
/************************************************/
void genret(stp *fsp)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     if(!fsp) {                         /* ^̂Ȃ́Aretp     */
      errchk(fprintf(pcdfile, " %sp\n", icd[iRET].mn)) ;
      mes(iRET) ;
      ic++      ;
     }
     else gen0t(iRET,fsp) ;             /* ^ɉretp         */
}

/************************************************/
/*    genlca(): lca߂̏o                   */
/*                 lca ""                 */
/************************************************/
void genlca(void) 
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile, " %s ", icd[iLCA].mn)) ;
     putconst() ;                       /* ̏o               */
     mes(iLCA) ;
     ic++ ;
}

/************************************************/
/*    genlda(): lda߂̏o                   */
/*                 lda  p  q                    */
/************************************************/
void genlda(int fp,int fq)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile, " %s %3d %7d\n", icd[iLDA].mn, fp, fq));
     mes(iLDA) ;
     ic++ ;
}

/************************************************/
/*    genixa(): ixa߂̏o                   */
/*                 ixa  p  q                    */
/************************************************/
void genixa(long fp,int fq)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile, " %s %3ld %7d\n", icd[iIXA].mn, fp, fq));
     mes(iIXA) ;
     ic++ ;
}

/***************************************************/
/*    genldc(): ldc߂̏o                      */
/*       ldci q        lX^bNɂ̂    */
/*       ldcr .  lX^bNɂ̂    */
/*       ldcb q        booleanlX^bN̂   */
/*       ldcn          nilX^bNɂ̂       */
/*       ldcc 'q'      X^bNɂ̂      */
/*       ldcs (  )  W̗vfX^bNɂ̂*/ 
/***************************************************/
void genldc(char ftype,long fq)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile, " %s", icd[iLDC].mn)) ;
     switch(ftype) {
      case 'i' : errchk(fprintf(pcdfile,"i %10ld\n",fq)) ;
                 break ;
      case 'r' : errchk(fprintf(pcdfile,"r ")) ;
                 putconst() ;
                 break ;
      case 'b' : errchk(fprintf(pcdfile,"b %10ld\n",fq)) ;
                 break ;
      case 'n' : errchk(fprintf(pcdfile,"n\n")) ;   /* fq͂Ȃ */
                 break ;
      case 'c' : errchk(fprintf(pcdfile,"c '%c'\n",(char)fq)) ;
                 break ;
      case 's' : errchk(fprintf(pcdfile,"s ")) ;
                 putconst() ;
     }
     mes(iLDC) ;
     ic++ ;
}

/************************************************/
/*    gencupent(): cup, entejp߂̏o       */
/*       cup  ̐  葱̃x          */
/*       ent  1܂2  x                  */
/*       ejp      x                  */
/************************************************/
void gencupent(enum pcdmnc fop, int fp1, int fp2) 
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile," %s %3d   L%4d\n",
                 icd[fop].mn, fp1, fp2 )) ;
                          
     mes(fop) ;
     ic++  ;
}

/************************************************/
/*    genjump(): jump֌W̖ߏo             */
/*                ujp / xjp / fjp               */
/************************************************/
void genjump(enum pcdmnc fop, int fq)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile," %s       L%4d\n",
                     icd[fop].mn,  fq)) ;
     mes(fop) ;
     ic++     ;
}

/************************************************/
/*    gencompare(): r֌W̖ߏo          */
/*                   les/leq/grt/geq/neq/equ    */
/************************************************/
void gencompare(enum pcdmnc fop, char ftypind,int fq)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile," %s%c",icd[fop].mn,ftypind)) ;
     if(ftypind == 'm') 
      errchk(fprintf(pcdfile,"%11d",fq));        /* m̎qo  */
     errchk(fprintf(pcdfile,"\n")) ;
     mes(fop) ;
     ic++     ;
}

/************************************************/
/*    convertint() : KvȂord߂𐶐    */
/*      boolean^񋓌^łȂ                */
/*      integer^ɓKȂ ord߂𐶐 */
/************************************************/
void convertint(stp *fsp)
{
     if(fsp == intptr) return ; 
     if((fsp->form == scalar) && (fsp->sf.sc.scalkind == declared)
        && (fsp != boolptr)) return ;
     if(fsp->form   == subrange) {
      if(fsp->sf.su.rangetype == intptr) return ;
      if((fsp->sf.su.rangetype->form == scalar) &&
          (fsp->sf.su.rangetype->sf.sc.scalkind == declared)
        && (fsp->sf.su.rangetype != boolptr)) return ;  
     }     
     gen0t(iORD,fsp) ; 
}

/************************************************/
/*    load() : [h֌W̖߂̏o           */
/************************************************/
void load(void)
{
     if(!gattr.typtr) return ;          /* ^ȂΉȂ     */

     switch(gattr.kind) {               /* ނŐU蕪           */
      case cst :                        /* 萔                       */
       if(gattr.typtr->form == scalar) {/* XJ[                   */
        if(gattr.typtr == intptr)       /*                        */
         genldc('i',gattr.cval.ival) ;
        else if(gattr.typtr == charptr) /*                        */
         genldc('c',gattr.cval.ival) ;
        else if(gattr.typtr == boolptr) /*   boolean                  */
         genldc('b',gattr.cval.ival) ;
        else if(gattr.typtr == realptr) /*                        */
         genldc('r',(long)nil) ;
        else                            /*   񋓌^                   */
         genldc('i',gattr.cval.ival);
       }
       else if(gattr.typtr == nilptr)   /*  nil ̎                  */
        genldc('n',(long)nil) ;
       else                             /* XJ[^,nilłȂ       */
        genldc('s',(long)nil) ;         /*  W^̏              */
       break ;

      case varbl :                      /* ϐ                       */
       if(gattr.access == drct)         /*  ڎQ                  */
        if(gattr.vlevel <= 1)           /*   `ʒu0,1̎        */
         gen1t(iLDO,gattr.typtr,gattr.dplmt) ;
        else 
         gen2t(iLOD,gattr.typtr,level-gattr.vlevel,gattr.dplmt) ;
       else                             /*  ԐڎQ                  */
        gen1t(iIND,gattr.typtr,gattr.idplmt) ;
       break ;
       
      case expr :                       /* ̏ꍇ͂łɒlstack*/
       break ;                          /* ڂĂ̂ŉȂ   */
     }
      
     gattr.kind = expr ;                /* ȍ~͎̈̂
                                          loadȂ    */
}

/****************************************************/
/*    loadaddress() : AhX[h֌W߂̏o  */
/****************************************************/
void loadaddress(void)
{
     if(!gattr.typtr) return ;          /* ^ȂΉȂ     */

     switch(gattr.kind) {               /* ނŐU蕪           */
      case cst :                        /* 萔                       */
        if(string(gattr.typtr))         /*  Ȃ              */
         genlca() ;                     /*  lcaߏo               */
        break ;

      case varbl :                      /* ϐ                       */
       if(gattr.access == drct)         /*  ڎQ                  */
        if(gattr.vlevel <= 1) 
         gen1(iLAO,gattr.dplmt) ;       /*  lao߂̏o             */
        else
         genlda(level-gattr.vlevel,gattr.dplmt) ; /* lda߂̏o    */
       else                             /*  ԐڎQ(indrct)          */  
        if(gattr.idplmt != 0)
         gen1t(iINC,nilptr,gattr.idplmt) ; /* inc߂̏o           */
       break ;

   /* case expr :*/                     /*                          */
                                        /* {͂̃[g͂Ȃ     */ 
     }

     gattr.kind   = varbl ;
     gattr.access = indrct ;
     gattr.idplmt = 0 ;
}

/******************************************/
/*     store() : XgA֌W߂̏o     */
/******************************************/
void store(attr fattr)
{

     if(!gattr.typtr) return ;          /* ^ȂΉȂ     */

     if(fattr.access == drct)           /* ڎQ                   */
      if(fattr.vlevel <= 1)
       gen1t(iSRO,fattr.typtr,fattr.dplmt) ;       /* sro         */
      else
       gen2t(iSTR,fattr.typtr,level-fattr.vlevel,fattr.dplmt) ;
                                                     /* str       */
     else                               /* ԐڎQ                   */
     gen0t(iSTO,fattr.typtr) ;          /*  sto                   */
                                        /* fattr.idplmt != 0 ̂   */
}

/****************************************/
/*    genchk()  : chk߂̏o         */
/*                 chk^    */
/****************************************/
void genchk(stp *fsp, int kind, long min, long max)
{
     if(!pcode) return ;                /* o͕svȂ烊^[       */
     putic() ;
     errchk(fprintf(pcdfile," %s",icd[iCHK].mn)) ;
     gentypindicator(fsp) ;             /* ^̏o                   */
     errchk(fprintf(pcdfile," %2d %ld %ld\n", kind,min, max)) ;

     mes(iCHK) ;
     ic++  ;
}

/*************************************************/
/*  checkbounds() : 㥉̃`FbN߂̏o  */
/*************************************************/
void checkbounds(stp *fsp,int kind)
{
  long lmin,lmax ;

     if((!debug)         ||             /* debugłȂ                */
        (!fsp)           ||             /* ^Ȃ                   */
        (fsp == intptr)  ||             /* ^                     */
        (fsp == realptr) ||             /* ^                     */
        (fsp == boolptr)) return ;      /* booleanȂ΃`FbNsv  */

     if((fsp->form <= subrange)         /* XJ[^͈͌^̎      */
     || (fsp->form == power)) {         /* ܂͏W^               */
      getbounds(fsp,&lmin,&lmax) ;      /* ̌^̏߂  */
      genchk(fsp,kind,lmin,lmax)  ;     /* chkߐ                */
     }
}
